<template lang="pug">
.dropdown.is-active( :class='bindClass' v-click-outside='() => active = false' )
	.dropdown-trigger( @click='active = !active' )
		.button( aria-haspopup="true" aria-controls="dropdown-menu" )
			span {{ modelValue ? (field ? modelValue[field] : modelValue) : "Не выбрано" }}
			span.icon.is-small
				i.fa-solid.fa-angle-down
	Transition
		.dropdown-menu( role="menu" v-if='active' )
			.dropdown-content
				template( v-for='(item, i) in data' )
					template( v-if='item.children' )
						a.dropdown-item.is-size-7.has-text-weight-bold.is-uppercase( @click='handleInput(item)' :class='{ "is-active": isActive(item) }' ) {{ item.name }}
						a.dropdown-item(
							v-for='(item, y) in item.children'
							:key='y' @click='handleInput(item)'
							:class='{ "is-active": isActive(item) }' ) &#8226; {{ field ? item[field] : item }} 
						hr.dropdown-divider( v-if='i !== data.length - 1' )
					template( v-else )
						a.dropdown-item(
							:key='i' @click='handleInput(item)'
							:class='{ "is-active": isActive(item) }' ) {{ field ? item[field] : item }} 
</template>

<script setup>
import { ref, computed } from "vue"

const props = defineProps({
	modelValue: {
		type: [ String, Object ],
		default: ""
	},
	data: {
		type: Array,
		default: []
	},
	field: {
		type: String,
		default: ""
	},
	type: {
		type: String,
		defaul: ""
	},
	expanded: Boolean
})

const emit = defineEmits([ "update:modelValue", "input" ])

const active = ref(false)

const bindClass = computed(() => [
	props.type ? `is-${props.type}` : "",
	props.expanded ? "is-expanded" : ""
])

const handleInput = value => {
	active.value = false
	emit("update:modelValue", value)
	emit("input", value)
}

const isActive = item => {
	if (props.field)
		return props.modelValue && props.modelValue[props.field] == item[props.field]

	return props.modelValue == item
}
</script>

<style lang="scss" scoped>
.dropdown {
	&.is-expanded {
		width: 100%;
		.dropdown-trigger {
			width: 100%;
			.button {
				justify-content: flex-start;
				width: 100%;
				.icon {
					margin-left: auto;
				}
			}
		}
	}
}
</style>